--[[
Copyright (C) GtX (Andy), 2017

Interface: 1.5.1.0 b1580

Author: GtX (LS-Modcompany)
Date: 03.02.2018

Support only at: http://ls-modcompany.com

History:
CLOSED BETA-1 @ 09.12.2017

Version: 1.0.0.0 - Release Edition @ 03.02.2018

Important:
No changes are to be made to this script without permission from GtX @ http://ls-modcompany.com

** PLACEABLE ONLY! **

Notes:
For use with 'SiloDisplay.lua' Version 1.1.0.0 and up Only.
--]]

SiloDisplayGui = {}

local SiloDisplayGui_mt = Class(SiloDisplayGui, YesNoDialog)

function SiloDisplayGui:new(target, custom_mt)
    if custom_mt == nil then
        custom_mt = SiloDisplayGui_mt
    end
    local self = YesNoDialog:new(target, custom_mt)

    self.newRange = nil

    return self
end

function SiloDisplayGui:onOpen(element)
    SiloDisplayGui:superClass().onOpen(self, element)
end

function SiloDisplayGui:setDisplayRange(setTable, setRange, displayId)
	self.displayId = displayId
	self.setRangeElement:setTexts(setTable)
	self.setRangeElement:setState(setRange, true)

	self.siloSearchText:setText(g_i18n:getText("warning_siloSearch"))
	self.siloInRangeText:setText(g_i18n:getText("warning_siloInRange"))
end

function SiloDisplayGui:changeRange(state)
    self.newRange = state
	local rangeCount = self:getTargetsInRange()
	self.siloCount:setText("( "..rangeCount.." )")
end

function SiloDisplayGui:onClickOk()
	SiloDisplayGui:superClass().onClickOk(self)

	self:doCallback(self.newRange)
end

function SiloDisplayGui:doCallback(newRange)
    self:close()
    if self.callback ~= nil then
        if self.target ~= nil then
            self.callback(self.target, newRange)
        else
            print("ERROR: [SiloDisplayGui.lua]  Target is missing.")
        end
    end
end

function SiloDisplayGui:loadCallback(callback, target)
    self.callback = callback
    self.target = target
end

function SiloDisplayGui:getTargetsInRange()
	local inRange = 0

	local xNode,yNode,zNode = getWorldTranslation(self.displayId)
    for target,_ in pairs(g_currentMission.siloTriggers) do
        local xSilo,ySilo,zSilo = getWorldTranslation(target.rootNode)
        local distance = Utils.vector3Length(xNode-xSilo, yNode-ySilo, zNode-zSilo)
        if distance < self.newRange then
			inRange = inRange + 1
        end
    end

    return inRange

end

function SiloDisplayGui:onClickBack()
    SiloDisplayGui:superClass().onClickBack(self)
end